#pragma config(Sensor, port2,  LED,            sensorVexIQ_LED)
#pragma config(Sensor, port3,  light,          sensorVexIQ_ColorGrayscale)
// #pragma config(Motor,  motor4,          Screwlift,     tmotorVexIQ, PIDControl, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

#pragma DebuggerWindows("debugStream");
short Screwlift = PORT4;
// tMotor Screwlift = motor4;


void SetConnectedMotorSpeed(short nPortIndex, int motorSpeed)
{
	TVexIQDeviceTypes nDeviceType;
	TDeviceStatus nDeviceStatus;
	short nDeviceVersion;

	getVexIqDeviceInfo(nPortIndex, nDeviceType, nDeviceStatus, nDeviceVersion);
	if (nDeviceType == vexIQ_SensorMOTOR)
	{
		setMotorSpeed(nPortIndex,motorSpeed);
	}
}

void displayValue(int index, int pwr)
{
	int x, y, ychar, ybar;
	char c='>';
	x = (index%6)*21+1;
	y = (index<6) ? 41 : 10;
	ychar = (index<6) ? 32 : 18;
	ybar = (index<6) ? 25 : 2;
	eraseRect(x+1, ybar+20, x+19, ybar);
	if(pwr==0) c = '-';
	else if(pwr<0)
	{
		c = '<';
		pwr = -pwr;
	}
	if(pwr>99) pwr=99;
	displayStringAt(x, y, " %2d", pwr);
	displayStringAt(x+3, ychar, " %c", c);
	fillRect(x+2, ybar+pwr/6, x+4, ybar);
}


long balcpt=0;
float avg60s;

task displayTime()
{
	float avg;
	while(true)
	{
		sleep(1000);
		avg = (1000. * balcpt)/(float)nPgmTime;
		displayCenteredTextLine(0, "%02d:%02d:%02d", nPgmTime/3600/1000, nPgmTime/60/1000%60, nPgmTime/1000%60);
		displayTextLine(1, "Avg %2.2f|Avg 60s %2.2f", avg, avg60s);
	}
}

task ratecounter()
{
	int cpt6s[10]={0,0,0,0,0,0,0,0,0,0};
	unsigned long curtime=6000;
	long prevbalcpt=0;
	long curbalcpt;
	long ptime;
	int cpt60s=0;
	int i=0;
	while(true)
	{
		while(curtime>nPgmTime)
		{
			sleep(1000);
			ptime=nPgmTime;
		}
		curtime +=6000;
		cpt60s-=cpt6s[i];
		curbalcpt=balcpt;
		cpt6s[i]=balcpt-prevbalcpt;
		prevbalcpt=curbalcpt;
		cpt60s+=cpt6s[i];
		i=(i+1)%10;
		avg60s = cpt60s / 60.;
	}
}

task main()
{

	int powerLevel[]={0, 0, 0, 50, 70, 100, 40, 70, 100, -40, -70, -100};
	int index=0;


	int threshold=0;
	int hysteresis;
	clearDebugStream();
	setTouchLEDBrightness(LED, 255);
	setColorMode(LED,colorTypeGrayscale_Ambient);
	setTouchLEDRGB(LED, 0, 0, 0);
	sleep(300);
	for(int i=0; i<10;i++)
	{
		threshold += getColorGrayscale(light);
	}
	threshold /= 10;
	hysteresis = threshold;
	setTouchLEDRGB(LED, 255, 255, 255);
	sleep(500);
	int vallight=0;
	for(int i=0; i<10;i++)
	{
		vallight += getColorGrayscale(light);
	}

	threshold = (2*threshold + vallight/10)/3;
	hysteresis = (threshold - hysteresis)/4;
	for(int i=3; i<12; i++)
	{
		displayValue(i, powerLevel[i]);
	}
	sleep(5000);
	startTask(displayTime);
	startTask(ratecounter);
	for(int i=3; i<12; i++)
	{
		SetConnectedMotorSpeed(i, powerLevel[i]);
	}
	eraseDisplay();

	clearTimer(timer1);
	int a;
	while(true)
	{
		displayCenteredBigTextLine(3, "%d", balcpt);
		//displayTextLine(4,"thr %d / hyst %d\n",threshold,hysteresis);

		do
		{
			a=getColorGrayscale(light);
			sleep(5);
		} while(a < (threshold+hysteresis));

		//writeDebugStream("%d>%d\n",a,threshold+hysteresis);
		do
		{
			a=getColorGrayscale(light);
			sleep(5);
		} while(a > (threshold-hysteresis));
		//writeDebugStream("%d<%d\n",a,threshold-hysteresis);
		balcpt++;
		//writeDebugStream("%d\t%d\t\n",nSysTime, balcpt);
	}
}
